# How to contribute

We welcome contributions from other people, all source code contributed to this project falls under the Project Licence, unless otherwise defined.  

## Testing

We have a handful of testers whom test the code before a release is completed. You are expected to test your own code before contributing to this project as much as you can.

## Submitting changes

Please send a [GitHub Pull Request](https://github.com/TinyPortal/ElkTP/pull/new/master) with a clear list of what you've done (read more about [pull requests](http://help.github.com/pull-requests/)). When you send a pull request, please detail what you are changing, this doesn't have to be in depth just a brief overview is great. 

Always write a clear log message for your commits. One-line messages are fine for small changes, but bigger changes should look like this:

    $ git commit -m "A brief summary of the commit
    > 
    > A paragraph describing what changed and its impact."

## Coding conventions

Start reading our code and you'll get the hang of it. We optimize for readability:

  * We indent using four spaces (soft tabs)
  * We try to put spaces after list items and method parameters (`[1, 2, 3]`, not `[1,2,3]`), around operators (`x += 1`, not `x+=1`), and around hash arrows.
  * This is open source software. Consider the people who will read your code, and make it look nice for them. It's sort of like driving a car: Perhaps you love doing donuts when you're alone, but with passengers the goal is to make the ride as smooth as possible.

Thanks,
The TinyPortal Team
